(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[      4687,        151]*)
(*NotebookOutlinePosition[      5355,        174]*)
(*  CellTagsIndexPosition[      5311,        170]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["CurvatureRelations", "ObjectName"],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["CurvatureRelations",
    FontFamily->"Courier"],
  " is a Boolean option for ",
  StyleBox["DefCovD",
    FontFamily->"Courier"],
  " specifying whether contractions of the Riemann tensor must be replaced by \
the Ricci tensor, and (if there is a metric) contractions of the Ricci tensor \
must be replaced by the RicciScalar tensor.\n\[FilledSmallSquare] ",
  StyleBox["CurvatureRelations",
    FontFamily->"Courier"],
  "[",
  StyleBox["covd",
    FontSlant->"Italic"],
  ", ",
  StyleBox["Riemann",
    FontFamily->"Courier"],
  "] returns the list of rules converting the contractions of the ",
  StyleBox["Riemann",
    FontFamily->"Courier"],
  " tensor of covd into its ",
  StyleBox["Ricci",
    FontFamily->"Courier"],
  " tensor.\n\[FilledSmallSquare] ",
  StyleBox["CurvatureRelations",
    FontFamily->"Courier"],
  "[",
  StyleBox["covd",
    FontSlant->"Italic"],
  ", ",
  StyleBox["Ricci",
    FontFamily->"Courier"],
  "] returns the list of rules converting the contractions of the ",
  StyleBox["Ricci",
    FontFamily->"Courier"],
  " tensor of covd into its ",
  StyleBox["RicciScalar",
    FontFamily->"Courier"],
  ".\n\[FilledSmallSquare] ",
  StyleBox["CurvatureRelations",
    FontFamily->"Courier"],
  "[",
  StyleBox["covd",
    FontSlant->"Italic"],
  "] returns the list of rules converting the contractions of the ",
  StyleBox["Riemann",
    FontFamily->"Courier"],
  " and ",
  StyleBox["Ricci",
    FontFamily->"Courier"],
  " tensors of ",
  StyleBox["covd",
    FontSlant->"Italic"],
  " ",
  "into ",
  StyleBox["Ricci",
    FontFamily->"Courier"],
  " and ",
  StyleBox["RicciScalar",
    FontFamily->"Courier"],
  ", respectively.\n\[FilledSmallSquare] ",
  StyleBox["CurvatureRelations",
    FontFamily->"Courier"],
  "[] returns all rules for those contractions of all derivatives."
}], "Usage"],

Cell[TextData[{
  "\[FilledSmallSquare] The default value for the option is ",
  StyleBox["True.\n",
    FontFamily->"Courier"],
  "\[FilledSmallSquare] All those rules are used by the function ",
  StyleBox[ButtonBox["ContractCurvature",
    ButtonData:>{"ContractCurvature.nb", None},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier"],
  ".\n\[FilledSmallSquare] See: ",
  ButtonBox["Section 4.5",
    ButtonData:>{
      FrontEnd`FileName[ {
        ParentDirectory[ ]}, "xTensorRefGuide.nb", CharacterEncoding -> 
        "iso8859-1"], "Covariant derivatives"},
    ButtonStyle->"Hyperlink"],
  ".\n\[FilledSmallSquare] See also: ",
  StyleBox[ButtonBox["DefCovD",
    ButtonData:>{"DefCovD.nb", None},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier"],
  ".\n\[FilledSmallSquare] New in version 0.\n\[FilledSmallSquare] Last \
update: 15-X-2007 for version 0.9.3 of ",
  StyleBox["xTensor`",
    FontFamily->"Courier"],
  "."
}], "Text"]
}, Open  ]]
},
FrontEndVersion->"5.0 for X",
ScreenRectangle->{{0, 1024}, {0, 768}},
WindowSize->{520, 600},
WindowMargins->{{Automatic, 199}, {66, Automatic}},
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 40, 0, 38, "ObjectName"],
Cell[1819, 55, 1891, 65, 232, "Usage"],
Cell[3713, 122, 958, 26, 144, "Text"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

